.nolist
include \masm32\include\masm32rt.inc

wInstrDLL MACRO args:VARARG
  ucInstr=128
  EXITM InstrDLL(args)
ENDM 
ucInstr=0
InstrDLL MACRO sPos, Src$, Sub$, sMode
LOCAL last_imm, sm1$
  push sMode+ucInstr	;; A: 4 args, easiest case
  push reparg_offset(Sub$)
  push reparg_offset(Src$)
  push sPos
  ucInstr=0		;; restore mode
  call ptrInstr		;; invoke InstrCi, sPos, reparg_offset(Src$), reparg_offset(Sub$), sMode
  EXITM <edx>	;; relative pos in edx, absolute in eax
ENDM

reparg_offset MACRO arg:REQ
LOCAL nustr, quot, ct
	ct = 0
	quot SUBSTR <arg>, 1, 1
	ifidn quot,<">				;; if 1st char double quote
		ct=1
	endif
	ifidn quot,<'>				;; if 1st char single quote
		ct=1
	endif
	if ct
		.data
		align 4
		nustr db arg, 0
		.code
		EXITM <offset nustr>	;; append name to ADDR operator
	else
		EXITM <arg>			;; else return arg
	endif
ENDM

; use together with [url=MbMiniDll.asc]MbMiniDll[/url]

.data?
hDll	dd ?
ptrInstr	dd ?

.code
start:
	mov hDll, rv(LoadLibrary, chr$("MbMiniDll"))		; rv is the retval macro ([url=\masm32\macros\macros.asm#"rv macro"]source[/url]), which returns eax
	.if eax
		mov ptrInstr, rv(GetProcAddress, hDll, chr$("InstrDLL"))
		.if eax
			MsgBox 0, str$(InstrDLL(1,"This is a string", "string", 0)), "The match is at position:", MB_OK
		.else
			invoke MessageBox, 0, chr$("InstrDLL not found"), 0, MB_OK
		.endif
		invoke FreeLibrary, hDll
	.else
		invoke MessageBox, 0, chr$("DLL not found"), 0, MB_OK
	.endif
	exit

end start

OPT_Tmp2Asm	1
